function ithomeEditorApi(id){
	var itEditorId = id;

	this.switchSourceMode = function(){
		UE.getEditor(itEditorId).execCommand( "source" );
	}

	var placeHolder;
    var that = this;
    UE.getEditor(itEditorId).addListener("blur", function () {
        var localHtml = UE.getEditor(itEditorId).getContent();
        if (!localHtml && that.placeHolder) {
            UE.getEditor(itEditorId)._setDefaultContent(that.placeHolder);
        }
    });
    UE.getEditor(itEditorId).addListener("ready", function(e) {
        var autoFocus = that.getQueryString("autofocus") === 'true';
        if(autoFocus){
            UE.getEditor(itEditorId).focus();
        }
        window.location.href = "ready-state://true" + (autoFocus ? '?autofocus=true' : '');
     });
    UE.getEditor(itEditorId).addListener("contentChange", function(e) {
        that.callback();
    });
    UE.getEditor(itEditorId).addListener("selectionchange", function(e) {
        that.enabledEditingItems();
    });

    this.insertparagraph = function(){
        UE.getEditor(itEditorId).execCommand('insertparagraph');
    }

    this.setPlaceholder = function(text){
        this.placeHolder = text;
        if (that.placeHolder) {
//            console.log("1");
            var localHtml = UE.getEditor(itEditorId).getContent();
            if (localHtml) {
//                console.log("2");
                if (localHtml.indexOf("initContent") !== -1) {
//                    console.log("3");
                    UE.getEditor(itEditorId)._setDefaultContent(that.placeHolder);
                }
            } else {
//                console.log("4");
                UE.getEditor(itEditorId)._setDefaultContent(that.placeHolder);
            }
        }

//        var localHtml = UE.getEditor(itEditorId).getContent();
//        console.log(localHtml);
//        if (!localHtml && that.placeHolder) {
//            console.log("setPlaceholder方法-设置placeholder");
//            UE.getEditor(itEditorId)._setDefaultContent(that.placeHolder);
//        }
    }

    this.callback = function() {
        window.location.href = "re-callback://" + encodeURIComponent(UE.getEditor(itEditorId).getContent());
    }

    var handle;
    this.enabledEditingItems = function() {
        clearTimeout(that.handle);

        that.handle = setTimeout(function(){
            var items = [];
                // 加粗
                if (UE.getEditor(itEditorId).queryCommandState('bold')) {
                    items.push('bold=true');
                }
                // 无序列表
                if (UE.getEditor(itEditorId).queryCommandState('insertunorderedlist')) {
                    items.push('unorderedList=true');
                }
                // 引用
                if (UE.getEditor(itEditorId).queryCommandState('blockquote')) {
                    items.push('blockquote=true');
                }
                // 字体颜色
                var color = eApi.getFontColorHex();
                if(color){
                    items.push('fontcolor=' + color.substring(1));
                }

                // 链接
                var range = UE.getEditor(itEditorId).selection.getRange();
                var orgNode = range.collapsed ? UE.getEditor(itEditorId).queryCommandValue('link') : UE.getEditor(itEditorId).selection.getStart();
                var orgLink = UE.dom.domUtils.findParentByTagName( orgNode, "a", true );
                if (orgLink){
                    items.push('linkhref=' + encodeURIComponent(orgLink['href']));
                    items.push('linktext=' + encodeURIComponent(orgLink['textContent']));
                }

                console.log("re-state://state?" + items.join('&'))
                window.location.href = "re-state://state?" + items.join('&');
        }, 500);
    }

	this.redo = function(){
		UE.getEditor(itEditorId).execCommand( "redo" );
	}

	this.undo = function(){
		UE.getEditor(itEditorId).execCommand( "undo" );
	}

	this.bold = function(){
		UE.getEditor(itEditorId).execCommand( 'bold');
	}
	this.isBold = function(){
		return UE.getEditor(itEditorId).queryCommandState( 'bold') === 1;
	}
	this.insertunorderedlist = function(){
		UE.getEditor(itEditorId).execCommand('insertunorderedlist');
	}

	this.blockquote = function(){
		UE.getEditor(itEditorId).execCommand( 'blockquote');
	}

	this.setFontColor = function(color){
		UE.getEditor(itEditorId).execCommand('forecolor', color.toLowerCase());
	}
	this.getFontColorHex = function(){
		return UE.getEditor(itEditorId).queryCommandValue('forecolor');
	}

	this.getFontColorClass = function(){
		var value =  UE.getEditor(itEditorId).queryCommandValue('forecolor');
		var colorclass = '';
		switch (value.toLowerCase()) {
			case '#d22222':
				colorclass = 'font-color-red';
				break;
			case '#eca500':
				colorclass = 'font-color-yellow';
				break;
			case '#ff7e00':
				colorclass = 'font-color-orange';
				break;
			case '#fb4e01':
				colorclass = 'font-color-orangered';
				break;
			case '#9b0080':
				colorclass = 'font-color-purple';
				break;
			case '#3e007b':
				colorclass = 'font-color-lyonsblue';
				break;
			case '#0f3193':
				colorclass = 'font-color-blue';
				break;
			case '#0091ea':
				colorclass = 'font-color-skyblue';
				break;
			case '#255965':
				colorclass = 'font-color-darkcyan';
				break;
			case '#00968b':
				colorclass = 'font-color-aqua';
				break;
			case '#548b30':
				colorclass = 'font-color-darkgreen';
				break;
			case '#379e28':
				colorclass = 'font-color-green';
				break;
		}
		return colorclass;
	}
	this.clearFontColor = function(){
		UE.getEditor(itEditorId).execCommand('forecolor', 'default');
	}

	this.getHtml = function(){
		return UE.getEditor(itEditorId).getContent();
	}

	this.insertHtml = function(value){
		UE.getEditor(itEditorId).execCommand('insertHtml', decodeURIComponent(value));
	}

	this.insertImage = function(src1){
        UE.getEditor(itEditorId).execCommand('insertimage', {src:decodeURIComponent(src1)});
	}

	this.setHtml = function(value){
	    var result = decodeURIComponent(value);
		UE.getEditor(itEditorId).setContent(result, false);
	}

	this.getSelectedText = function(){
		var selectedText = UE.getEditor(itEditorId).selection.getText();
        return selectedText;
	}

	this.insertLink = function(linkText, href){
	    var reslink = decodeURIComponent(linkText);
	    var reshref = decodeURIComponent(href);
        if(!that.hrefStartWith(reshref, ["http", "ftp://", 'ed2k://', 'ithome://'])) {
            var preFix = (reshref.indexOf('.ithome.com') > -1 || reshref.indexOf('.lapin365.com') > -1) ? 'https://' : 'http://';
            reshref  = preFix + reshref;
        }
        var range = UE.getEditor(itEditorId).selection.getRange();
        var orgNode = range.collapsed ? UE.getEditor(itEditorId).queryCommandValue('link') : UE.getEditor(itEditorId).selection.getStart();
        var orgLink = UE.dom.domUtils.findParentByTagName( orgNode, "a", true );
	    if(orgLink){
	        //修改
	        var orgText = orgLink['textContent'];
            var obj = {
                'href' : reshref,
                'target' : "_blank",
                'title' : reslink,
                '_href': reshref
            };
            if(orgText && reslink != orgText){
                orgLink['textContent'] =  obj.textValue = reslink;
                range.selectNode(orgLink).select()
            }
            if(range.collapsed){
                obj.textValue = reslink;
            }
            UE.getEditor(itEditorId).execCommand('link', UE.utils.clearEmptyAttrs(obj) );
	    } else {
	        //插入新连接
            UE.getEditor(itEditorId).execCommand( 'link', {href:reshref, textValue:reslink, target:'_blank'});
	    }

	}

	this.unlink = function(){
	    UE.getEditor(itEditorId).execCommand('unlink');
	}

	this.isFocus = function(){
        return UE.getEditor(itEditorId).isFocus();
    }
    this.setblur = function(){
        UE.getEditor(itEditorId).blur();
    }

	this.setFocus = function(){
        UE.getEditor(itEditorId).focus();
    }

	this.hasContent = function() {
        return UE.getEditor(itEditorId).hasContents();
    }

	this.hrefStartWith = function(href, arr){
        href = href.replace(/^\s+|\s+$/g, '');
        for(var i=0,ai;ai=arr[i++];){
            if(href.indexOf(ai)==0){
                return true;
            }
        }
        return false;
    }

    this.getQueryString = function(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
        var r = window.location.search.substr(1).match(reg);
        if (r != null) return unescape(r[2]); return null;
    }

//    this.replaceImg = function(source, src) {
//        var iframe = window.document.getElementById("ueditor_0");
//        var win = iframe.contentWindow || iframe;
//        var imgs = win.document.getElementsByTagName("img");
//        for (var i = 0; i < imgs.lenth; i++) {
//            var img = imgs[i];
//            if (img.src == source) {
//                img.src = src;
//                break;
//            }
//        }
//    }
}
